import * as R from "ramda";
export class EventEmitter {
    listeners = {};
    id = 0;
    on(name, cb) {
        let key = this.id++;
        this.listeners[name] = this.listeners[name] || {};
        this.listeners[name][key] = cb;
        // unsubscribe
        return () => {
            delete this.listeners[name][key];
        };
    }
    emit(name, ...args) {
        let cbs = R.values(this.listeners[name]) ?? [];
        cbs.forEach((cb) => { cb(...args); });
    }
}
